using Rational.Test.Ft;
using Rational.Test.Ft.Sys;
using Rational.Test.Ft.Domain;
using Rational.Test.Ft.Domain.Net;
using SDK.Sample.Value;

namespace SDK.Sample
{
	/// <summary>
	/// Summary description for ExtendedButtonProxy.
	/// </summary>
	public class ButtonOverrideProxy:ButtonProxy
	{
		public ButtonOverrideProxy(NetTestDomainImplementation domain,
			IChannel channel,
			System.Object theAUTObject): base( domain, channel, theAUTObject)
		{
		}

		/// <summary>
		/// 
		/// </summary>
		/// <returns></returns>
		public override System.Collections.Hashtable GetProperties()
		{
			System.Collections.Hashtable properties =  base.GetProperties();
            properties.Add("simpleVlaue",new SimpleValue("Fubar"));
	        return properties;
		}
		
		/// <summary>
		/// 
		/// </summary>
		/// <param name="propertyName"></param>
		/// <returns></returns>
		public override object GetProperty(string propertyName)
		{
			if ( propertyName == "simpleValue")
				return new SimpleValue("Fubar");
			return base.GetProperty(propertyName);
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="action"></param>
		public override void ProcessMouseEvent(IMouseActionInfo action)
		{
			System.String method = null;
			int clicks = action.GetClickCount();	
	
			if (clicks == 1)
				// usually when clicks == 1,  the method is click, now we've changed to method to doubleClick
				method = "doubleClick"; //method = "click";
			else if (clicks == 2)
				// usually when clicks == 2,  the method is doubleClick, now we've changed to method to click
				method = "click"; // method = "doubleClick";
			else 
				method = "nClick";	
	
			// The method to be recorded is represented using MethodSpecification class in RFT
			MethodSpecification methodSpec = MethodSpecification.ProxyMethod(this, method,null);

			// The method for the user action is set here
			action.SetActionMethodSpecification(methodSpec);
		}

	}
}
